// 场景相机相关操作
import { Viewer, Cartesian3, Math } from 'cesium'
/**
 * 将三维球定位到中国
 * @param viewer :Viewer对象
 */
function flyToChina(viewer: Viewer) {
  viewer.camera.flyTo({
    destination: Cartesian3.fromDegrees(103.84, 31.15, 10350000),
    orientation: {
      heading: Math.toRadians(0),
      pitch: Math.toRadians(-90),
      roll: Math.toRadians(0),
    },
    complete: function callback() {
      // 定位完成之后的回调函数
    },
  })
}
export { flyToChina }
